// Example of using LV-EZ1 serial output

#include <NewSoftSerial.h>

// Digital pins, to whom you have connected the sensor
#define SENSOR_PIN_TX 2
#define SENSOR_PIN_RX 3

// Declaration of software serial communication object
NewSoftSerial sensor_serial(SENSOR_PIN, SENSOR_PIN_RX, true);

// Function returning distance in inches
int get_distance()
{
  char data[4] = "000";
  char header = ' ';
  // Waiting for appearance of data header ("R" letter)
    while (header != 'R')
    header = sensor_serial.read();
  // Reading every digit of distance
  while (sensor_serial.available() < 4);
  // Reading every digit of distance
  for (byte i = 0; i < 3; i++)
    data[i] = sensor_serial.read();
  // Checking correctness of data packet ending ("\r" character)
  header = sensor_serial.read();
  if (header != 13)
    return -1; // Value returned if data packet is corrupt
  return atoi(data);
}


void setup()
{
  Serial.begin(9600);
  pinMode(SENSOR_PIN, INPUT);
  pinMode(3, OUTPUT);
  digitalWrite(3, LOW);
  sensor_serial.begin(9600);
}


void loop()
{
  int distance = 0;
  // Checking existence of data in buffer
  while (sensor_serial.available())
  {
    distance = get_distance();
    if (distance > 0) // Checking packet integrity
      Serial.println(distance, DEC);
  }
}
